<template>
	<v-container>
		<div v-frag>
			<h3 class="mb-1">User Info</h3>
			<v-card rounded="lg" class="mb-8">
				<v-card-text class="d-md-flex justify-space-between">
					<div v-if="isLoading">Loading...</div>
					<div v-else-if="hasError">There was an error loading your profile. Please refresh.</div>
					<div v-frag v-else>
						<div>
							You are logged in as
							<strong>{{ user.email }}</strong
							>.
						</div>

						<div>
							<router-link style="white-space: nowrap" :to="{ name: 'change-password' }">Change Password</router-link>
						</div>
					</div>
				</v-card-text>
			</v-card>

			<api-keys v-if="isLoaded" :apiKeys="user.apiKeys" />
		</div>
	</v-container>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api';
import { useUser } from '../../store/modules/user';
import ApiKeys from '../api-keys/ApiKeys.vue';

export default defineComponent({
	components: {
		ApiKeys,
	},
	setup(_, { root }) {
		const { user, isLoading, isLoaded, hasError } = useUser(root.$store);

		return {
			isLoading,
			isLoaded,
			hasError,
			user,
		};
	},
});
</script>
